#cs
Imtended originally to demonstrate what a Presets dialog might look like, but has become (perhaps) a prototype.

Here's what the Help might say:
- You can either choose a Preset (which we have tested), do it yourself (DIY), or choose a Preset and then modify it.
- If the label below the Presets group shows "Preset" and a number, the checkboxes show the features the form will have.
- If it says Failed, AutoIt won't create a form with the features you have requested.
- If it says Custom, you deviates from Presets by choosing the CReset radio button and/or cby hecking one or more checkboxes.
Because of the strange ways of Windows, you may not get what you asked for! The picture shows what will show in the design area
if you click on OK.

Presets are numbered because they are too complicated for captions of radio buttons. Could add Hints.

It would be nice for the user to see what his form will look like, because the dialog is large enough that he can't see the
design window (and AutoIt may claim success when it ignores some styles). This is what I have tried to do with ShowTestForm().
As it is now, the user has to click on TestForm to close it. I would like to be able to make it appear as if part of the form.
I have more to learn about AutoIt!

The Presets are based on Analysis of Form Styles.wb3 and .pdf.

The Presets can be refined, and more added. Perhaps in the future users would be able to add their own.

The Styles and ExStyles that are here are those in Koda now, less those that don't work or don't belong to Form, plus one or two
that I have added.

$chkCloseBox is a problem. There seems to be no WS_ or WS_EX_ constant that directly provides a close box without sysmenu and other
boxes.

#ce
#include <Constants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
Opt("MustDeclareVars",1)
Global $gParamStyles,$gParamExStyles	; styles and exStyles parameter of GuiCreate
Global $gWinInStyles,$gWinInExStyles	; the above, plus styles forced by GuiCreate
Global $gWinOutStyles,$gWinOutExStyles	; what Windows actually did, per GetWindowLong. If GuiCreate failed, ""
Global $TestForm
Global $presetStylesAr[10][2]
$presetStylesAr[1][0] = BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU)	; -1
$presetStylesAr[1][1] = 0
$presetStylesAr[2][0] = BitOR($WS_POPUPWINDOW,$WS_CAPTION) ; $WS_SYSMENU
$presetStylesAr[2][1] = $WS_EX_CONTEXTHELP
$presetStylesAr[3][0] = $WS_POPUP
$presetStylesAr[3][1] = 0
$presetStylesAr[4][0] = BitOR($WS_DLGFRAME,$WS_BORDER) ; 0
$presetStylesAr[4][1] = 0
$presetStylesAr[5][0] = BitOR($WS_DLGFRAME, $WS_CAPTION, $WS_HSCROLL) ; $WS_HSCROLL
$presetStylesAr[5][1] = 0
$presetStylesAr[6][0] = BitOR($WS_POPUPWINDOW, $WS_DLGFRAME)
$presetStylesAr[6][1] = 0
$presetStylesAr[7][0] = BitOR($WS_SIZEBOX,$WS_SYSMENU,$WS_CAPTION) ; $WS_SIZEBOX
$presetStylesAr[7][1] = 0
$presetStylesAr[8][0] = $WS_OVERLAPPEDWINDOW
$presetStylesAr[8][1] = 0
$presetStylesAr[9][0] = BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU) ; -1
$presetStylesAr[9][1] = $WS_EX_CONTEXTHELP
Global Const $kStylesAr[15][2] = [[$WS_OVERLAPPEDWINDOW,"$WS_OVERLAPPEDWINDOW"],[$WS_POPUPWINDOW,"$WS_POPUPWINDOW"], _
	[$WS_CAPTION,"$WS_CAPTION"], [$WS_SYSMENU,"$WS_SYSMENU"], [$WS_DLGFRAME,"$WS_DLGFRAME"], [$WS_MINIMIZEBOX,"$WS_MINIMIZEBOX"], _
	[$WS_MAXIMIZEBOX,"$WS_MAXIMIZEBOX"], [$WS_SIZEBOX,"$WS_SIZEBOX"], [$WS_HSCROLL,"$WS_HSCROLL"], [$WS_VSCROLL,"$WS_VSCROLL"], _
	[$DS_MODALFRAME,"$DS_MODALFRAME"],  [$WS_BORDER,"$WS_BORDER"],[$WS_POPUP,"$WS_POPUP"],[$WS_CHILD,"$WS_CHILD"], _
	[$WS_CLIPSIBLINGS,"$WS_CLIPSIBLINGS"]]
Global Const $kExStylesAr[12][2] = [[$WS_EX_CONTEXTHELP,"$WS_EX_CONTEXTHELP"],[$WS_EX_TOPMOST,"$WS_EX_TOPMOST"], _
	[$WS_EX_ACCEPTFILES,"$WS_EX_ACCEPTFILES"], [$WS_EX_MDICHILD,"$WS_EX_MDICHILD"], [$WS_EX_LEFTSCROLLBAR,"$WS_EX_LEFTSCROLLBAR"], _
	[$WS_EX_WINDOWEDGE,"$WS_EX_WINDOWEDGE"], [$WS_EX_RIGHT,"$WS_EX_RIGHT"], _
	[$WS_EX_TOOLWINDOW,"$WS_EX_TOOLWINDOW"], [$WS_EX_TRANSPARENT,"$WS_EX_TRANSPARENT"], [$WS_EX_COMPOSITED,"$WS_EX_COMPOSITED"], _
	[$WS_EX_CLIENTEDGE,"$WS_EX_CLIENTEDGE"],[$WS_EX_DLGMODALFRAME,"$WS_EX_DLGMODALFRAME"]]

;Global $TestContinue
#Region ### START Koda GUI section ### Form=F:\AutoIt scripts\Koda devel\Styles with presets suggestion.kxf
Local $Form1 = GUICreate("Styles", 458, 684, -1, -1, 0)
Local $chkResizeable = GUICtrlCreateCheckbox("Resizable", 215, 167, 97, 17)
Local $chkHorizScroll = GUICtrlCreateCheckbox("Horizontal scroll bar", 215, 191, 121, 17)
Local $chkVertScroll = GUICtrlCreateCheckbox("Vertical scroll bar on the right", 215, 213, 169, 17)
Local $chkModal = GUICtrlCreateCheckbox("Modal", 215, 352, 65, 17)
Local $chkOnTop = GUICtrlCreateCheckbox("Always on top", 215, 372, 97, 17)
Local $chkAccept = GUICtrlCreateCheckbox("Accept filenames into Input and Edit controls", 215, 393, 241, 17)
Local $chkMDI = GUICtrlCreateCheckbox("Simulate MDI interface", 215, 414, 145, 17)
Local $chkScrollLeft = GUICtrlCreateCheckbox("Vertical scroll bar on the left", 215, 230, 161, 17)
Local $chkRaisedEdge = GUICtrlCreateCheckbox("Raised edges", 215, 246, 201, 17)
Local $chkTextRight = GUICtrlCreateCheckbox("Right-aligned text", 215, 436, 145, 17)
Local $chkToolBar = GUICtrlCreateCheckbox("Form is toolbar", 215, 455, 145, 17)
Local $chkTransparent = GUICtrlCreateCheckbox("Form is transparent", 215, 477, 121, 17)
Local $chkSunkenClient = GUICtrlCreateCheckbox("Sunken client area", 215, 268, 121, 17)
Local $chkDoubleBuffer = GUICtrlCreateCheckbox("Double-buffered to reduce flicker", 215, 498, 177, 17)
Local $chkThinBorder = GUICtrlCreateCheckbox("Thin-line border", 215, 305, 105, 17)
Local $lblStatus = GUICtrlCreateLabel("Custom style", 56, 184, 69, 17, $SS_CENTER)
GUICtrlSetFont(-1, 8, 800, 0, "MS Serif")
GUICtrlSetColor(-1, 0xFF8040)
Local $Group2 = GUICtrlCreateGroup("Presets", 8, 8, 177, 169)
Local $radPreset1 = GUICtrlCreateRadio("1", 16, 24, 65, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
Local $radPreset2 = GUICtrlCreateRadio("2", 16, 44, 65, 17)
Local $radPreset3 = GUICtrlCreateRadio("3", 16, 65, 65, 17)
Local $radPreset4 = GUICtrlCreateRadio("4", 16, 82, 65, 17)
Local $radPreset5 = GUICtrlCreateRadio("5", 16, 103, 65, 17)
Local $radPreset6 = GUICtrlCreateRadio("6", 16, 125, 65, 17)
Local $radReset = GUICtrlCreateRadio("Reset", 64, 152, 65, 17)
Local $radPreset7 = GUICtrlCreateRadio("7", 95, 27, 65, 17)
Local $radPreset8 = GUICtrlCreateRadio("8", 95, 47, 65, 17)
Local $radPreset9 = GUICtrlCreateRadio("9", 95, 68, 65, 17)
Local $radPreset10 = GUICtrlCreateRadio("10", 95, 85, 65, 17)
Local $radPreset11 = GUICtrlCreateRadio("11", 95, 106, 65, 17)
Local $radPreset12 = GUICtrlCreateRadio("12", 95, 128, 65, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $btnOK = GUICtrlCreateButton("OK", 352, 628, 41, 25)
Local $btnCancel = GUICtrlCreateButton("Cancel", 403, 628, 41, 25)
Local $edtStyleParam = GUICtrlCreateEdit("", 8, 224, 177, 89, BitOR($ES_AUTOVSCROLL,$ES_AUTOHSCROLL,$ES_READONLY))
GUICtrlSetData(-1, "")
GUICtrlCreateLabel("AutoIt style parameter", 8, 208, 106, 17)
GUICtrlCreateLabel("AutoIt exStyle parameter", 8, 320, 119, 17)
Local $edtExStyleParam = GUICtrlCreateEdit("", 8, 336, 177, 49, BitOR($ES_AUTOVSCROLL,$ES_AUTOHSCROLL,$ES_READONLY))
GUICtrlSetData(-1, "")
Local $chkSysMenu = GUICtrlCreateCheckbox("System menu", 215, 49, 97, 17)
Local $chkCtxHelp = GUICtrlCreateCheckbox("Context help", 215, 86, 105, 17)
Local $chkCaption = GUICtrlCreateCheckbox("Caption", 215, 66, 81, 17)
Local $chkMinBox = GUICtrlCreateCheckbox("Minimize box", 215, 105, 105, 17)
Local $chkMaxBox = GUICtrlCreateCheckbox("Maximize box", 215, 123, 105, 17)
Local $chkCloseBox = GUICtrlCreateCheckbox("Close box", 215, 143, 89, 17)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateLabel("Title bar", 216, 24, 42, 17)
GUICtrlSetFont(-1, 8, 400, 4, "MS Sans Serif")
Local $chkDoubleBorder = GUICtrlCreateCheckbox("Double-line border", 215, 288, 113, 17)
Local $chkChild = GUICtrlCreateCheckbox("Child", 216, 328, 105, 17)
Local $edtAIstylesInclForced = GUICtrlCreateEdit("", 8, 409, 177, 105, BitOR($ES_AUTOVSCROLL,$ES_AUTOHSCROLL,$ES_READONLY))
GUICtrlSetData(-1, "")
GUICtrlCreateLabel("AutoIt styles/exstyles including forced", 8, 393, 181, 17, $WS_CLIPSIBLINGS)
GUICtrlCreateLabel("AutoIt styles/exstyles Windows lacks", 8, 528, 178, 17)
Local $edtStylesWinLacks = GUICtrlCreateEdit("", 8, 547, 177, 41, BitOR($ES_AUTOVSCROLL,$ES_AUTOHSCROLL,$ES_READONLY))
GUICtrlSetData(-1, "")
GUICtrlCreateLabel("AutoIt styles/exstyles Windows added", 9, 593, 183, 17)
Local $edtStylesWinAdded = GUICtrlCreateEdit("", 9, 612, 177, 41, BitOR($ES_AUTOVSCROLL,$ES_AUTOHSCROLL,$ES_READONLY))
GUICtrlSetData(-1, "")
Local $chkShowTestForm = GUICtrlCreateCheckbox("ShowTestForm", 200, 632, 97, 17)
GUICtrlSetFont(-1, 8, 400, 2, "MS Sans Serif")
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

Const $allChksVec[21] = [$chkSysMenu, $chkCaption, $chkCtxHelp, $chkMinBox, $chkMaxBox, $chkCloseBox, _
	$chkResizeable, $chkHorizScroll, $chkVertScroll, $chkModal, $chkOnTop, $chkAccept, $chkMDI, $chkScrollLeft, $chkRaisedEdge, _
	$chkTextRight, $chkToolBar, $chkTransparent, $chkSunkenClient, $chkDoubleBuffer, $chkThinBorder]
DoPreset(1)
;AutoIt_Debugger_Command:Disable_Debug
While 1
	Local $nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE,$btnCancel,$btnOK
			Exit
		Case $chkAccept
			DoCheckBox($chkAccept,0,$WS_EX_ACCEPTFILES)
		Case $chkCaption
			DoCheckBox($chkCaption,$WS_CAPTION,0)
		Case $chkChild
			DoCheckBox($chkChild,$WS_CHILD,0)
		Case $chkCloseBox
			; do nothing
		Case $chkCtxHelp
			DoCheckBox($chkCtxHelp,0,$WS_EX_CONTEXTHELP)
		Case $chkDoubleBorder
			DoCheckBox($chkDoubleBorder,0,$WS_EX_DLGMODALFRAME)
		Case $chkDoubleBuffer
			DoCheckBox($chkDoubleBuffer,0,$WS_EX_COMPOSITED)
		Case $chkHorizScroll
			DoCheckBox($chkHorizScroll,$WS_HSCROLL,0)
		Case $chkMaxBox
			DoCheckBox($chkMaxBox,$WS_MAXIMIZEBOX,0)
		Case $chkMDI
			DoCheckBox($chkMDI,0,$WS_EX_MDICHILD)
		Case $chkMinBox
			DoCheckBox($chkMinBox,$WS_MINIMIZEBOX,0)
		Case $chkModal
			DoCheckBox($chkModal,$DS_MODALFRAME,0)
		Case $chkOnTop
			DoCheckBox($chkOnTop,0,$WS_EX_TOPMOST)
		Case $chkRaisedEdge
			DoCheckBox($chkRaisedEdge,0,$WS_EX_WINDOWEDGE)
		Case $chkResizeable
			DoCheckBox($chkResizeable,$WS_SIZEBOX,0)
		Case $chkScrollLeft
			DoCheckBox($chkScrollLeft,0,$WS_EX_LEFTSCROLLBAR)
		Case $chkSunkenClient
			DoCheckBox($chkSunkenClient,0,$WS_EX_CLIENTEDGE)
		Case $chkSysMenu
			DoCheckBox($chkSysMenu,$WS_SYSMENU,0)
		Case $chkTextRight
			DoCheckBox($chkTextRight,0,$WS_EX_RIGHT)
		Case $chkThinBorder
			DoCheckBox($chkThinBorder,$WS_BORDER,0)
		Case $chkToolBar
			DoCheckBox($chkToolBar,0,$WS_EX_TOOLWINDOW)
		Case $chkTransparent
			DoCheckBox($chkTransparent,0,$WS_EX_TRANSPARENT)
		Case $chkVertScroll
			DoCheckBox($chkVertScroll,0,$WS_VSCROLL)
		Case $radPreset1
			DoPreset(1)
		Case $radPreset2
			DoPreset(2)
		Case $radPreset3
			DoPreset(3)
		Case $radPreset4
			DoPreset(4)
		Case $radPreset5
			DoPreset(5)
		Case $radPreset6
			DoPreset(6)
		Case $radPreset7
			DoPreset(7)
		Case $radPreset8
			DoPreset(8)
		Case $radPreset9
			DoPreset(9)
		Case $radPreset10
			DoPreset(10)
		Case $radPreset11
			DoPreset(11)
		Case $radPreset12
			DoPreset(12)
		Case $radReset
			DoPreset(0)
	EndSwitch
WEnd
;AutoIt_Debugger_Command:Enable_Debug

Func DoPreset($nPres)
	Switch $nPres
	Case 1
		Local $chksVec[5] = [$chkSysMenu,$chkCaption,$chkMinBox,$chkCloseBox]
	Case 2
		Local $chksVec[5] = [$chkSysMenu,$chkCaption,$chkCloseBox,$chkCtxHelp]
	Case 3
		Local $chksVec = 0
	Case 4
		Local $chksVec[1] = [$chkCaption]
	Case 5
		Local $chksVec[2] =[$chkCaption,$chkHorizScroll]
	Case 6
		Local $chksVec[3] = [$chkSysMenu,$chkCaption,$chkCloseBox]
	Case 7
		Local $chksVec[4] = [$chkSysMenu,$chkCaption,$chkCloseBox,$chkResizeable]
	Case 8
		Local $chksVec[5] = [$chkSysMenu,$chkCaption,$chkMinBox,$chkMaxBox,$chkCloseBox]
	Case 9
		Local $chksVec[5] = [$chkSysMenu,$chkCaption,$chkMinBox,$chkCloseBox,$chkCtxHelp]
	Case 0	; reset
		Local $chksVec = 0
	Case Else
		MsgBox(0,"","Not defined yet")
		Return
	EndSwitch
	If IsArray($chksVec) Then
		For $i = 0 To UBound($chksVec)-1
			GUICtrlSetState($chksVec[$i],$GUI_CHECKED)
		Next
		Local $vec = GetVecElsNotIn($chksVec,$allChksVec)
		For $i = 0 to UBound($vec)-1
			GUICtrlSetState($vec[$i],$GUI_UNCHECKED)
		Next
	Else
		For $i = 0 to UBound($allChksVec)-1
			GUICtrlSetState($allChksVec[$i],$GUI_UNCHECKED)
		Next
	EndIf
	ShowParamStyles($presetStylesAr[$nPres][0])
	ShowExStyles($presetStylesAr[$nPres][1])
	ShowWinInStyles()
	ShowStatus()
EndFunc

Func DoCheckBox($ctrlID,$nStyle,$nExStyle)
	If $nStyle<>0 Then
		If IsChecked($ctrlID) Then
			ShowParamStyles(BitOR($gParamStyles,$nStyle))
		Else
			ShowParamStyles(BitAND($gParamStyles,BitNOT($nStyle)))
		EndIf
	EndIf
	If $nExStyle<>0 Then
		If IsChecked($ctrlID) Then
			ShowExStyles(BitOR($gParamExStyles,$nExStyle))
		Else
			ShowExStyles(BitAND($gParamExStyles,BitNOT($nExStyle)))
		EndIf
	EndIf
	ShowWinInStyles()
	ShowStatus()
EndFunc

Func ShowParamStyles($nStyles)
	$gParamStyles = $nStyles
	Local $t = ""
	Switch $gParamStyles
	Case BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU)
		$t = "-1"
	Case Else
		For $i = 0 to UBound($kStylesAr,1)-1
			If BitAND($nStyles,$kStylesAr[$i][0])=$kStylesAr[$i][0] Then
				$t &= "," & @CRLF & $kStylesAr[$i][1]
				$nStyles = BitAND($nStyles,BitNOT($kStylesAr[$i][0]))
			EndIf
		Next
		If $nStyles<>0 Then
			MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown style(s) 0x" & Hex($nStyles))
		EndIf
		$t = StringMid($t,4)
	EndSwitch
	GUICtrlSetData($edtStyleParam,$t)
	$t = StringReplace($t,@CRLF," ")
	Return $t
EndFunc

Func ShowExStyles($nExStyles)
	$gParamExStyles = $nExStyles
	Local $t = ""
	If BitAND($nExStyles,$WS_EX_OVERLAPPEDWINDOW)=$WS_EX_OVERLAPPEDWINDOW Then
		$t &= "," & @CRLF & "$WS_EX_OVERLAPPEDWINDOW"
		$nExStyles = BitAND($nExStyles,BitNOT($WS_EX_OVERLAPPEDWINDOW))
	EndIf
	$t = ConvertExStylesToText($nExStyles)
	GUICtrlSetData($edtExStyleParam,$t)
EndFunc

Func ShowWinInStyles()
	Local $t, $nStyles = $gParamStyles
	$nStyles = BitOR($nStyles,$WS_CLIPSIBLINGS)	 ; forced by AutoIt
	Select
	Case $nStyles=-1
		$nStyles = BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU)
	Case BitAND($nStyles,BitOR($WS_MAXIMIZEBOX,$WS_SIZEBOX))<>0	; forced by AutoIt
		$nStyles = BitOR($nStyles,$WS_SYSMENU)
	EndSelect
	$gWinInStyles = $nStyles
	$gWinInExStyles = $gParamExStyles
	ShowAllStyles($gWinInStyles,$gWinInExStyles,$edtAIstylesInclForced)
EndFunc
Func IsChecked($ctrlID)
	Return BitAND(GUICtrlRead($ctrlID),$GUI_CHECKED)=$GUI_CHECKED
EndFunc

Func GetVecElsNotIn($exclVec,$mainVec)
	Local $retVec[UBound($mainVec)]
	Local $qRetEls = -1
	For $mainEl In $mainVec
		Local $found = False
		For $exclEl In $exclVec
			if $exclEl=$mainEl Then
				$found = True
				ExitLoop
			EndIf
		Next
		If Not $found Then
			$qRetEls += 1
			$retVec[$qRetEls] = $mainEl
		EndIf
	Next
	ReDim $retVec[$qRetEls]
	Return $retVec
EndFunc

Func ShowStatus()
Local $n = 0,$hndl
	for $i = 1 to UBound($presetStylesAr,1)-1
		If $presetStylesAr[$i][0]=$gParamStyles And $presetStylesAr[$i][1]=$gParamExStyles Then
			$n = $i
			ExitLoop
		EndIf
	Next
	$hndl = GUICreate("title",-200,-200,-200,-200,$gParamStyles,$gParamExStyles)
	Local $bWorks = $hndl<>0 and @error=0
	if $bWorks Then
		$gWinOutStyles = _C_GetWindowLong($hndl,$GWL_STYLE)
		$gWinOutExStyles = _C_GetWindowLong($hndl,$GWL_EXSTYLE)
		GUIDelete($hndl)
		GUICtrlSetState($btnOK,$GUI_ENABLE)
	Else
		$gWinOutStyles = ""
		$gWinOutExStyles = ""
		GUICtrlSetState($btnOK,$GUI_DISABLE)
	EndIf
	If $n>0 Then
		GUICtrlSetData($lblStatus,"Preset " & $n)
		GUICtrlSetFont($lblStatus,8.5,800)			; bold
		GUICtrlSetColor($lblStatus,0x007f00)	; green
		ShowTestForm()
	Else
		If $bWorks Then
			GUICtrlSetData($lblStatus,"Custom")
			GUICtrlSetFont($lblStatus,8.5,800)			; bold
			GUICtrlSetColor($lblStatus,0x0000ff)	; blue
			ShowTestForm()
		Else
			GUICtrlSetData($lblStatus,"Failed")
			GUICtrlSetFont($lblStatus,8.5,800)			; bold
			GUICtrlSetColor($lblStatus,0xff0000)	; red
		EndIf
	EndIf
ConsoleWrite(Hex($gWinInStyles)&","&Hex($gWinInExStyles)&" =>"&Hex($gWinOutStyles)&","&Hex($gWinOutExStyles)&@CRLF)
	Local $nWinLacks=0,$nWinAdded=0,$mask,$sLacks,$sAdded
	If $gWinOutStyles<>"" and $gWinOutStyles<>$gWinInStyles Then
		For $iShft = 0 to 31
			$mask = BitShift(1,-$iShft)		; negative is left
			If BitAND($gWinOutStyles,$mask)<>BitAND($gWinInStyles,$mask) Then
				If BitAND($gWinOutStyles,$mask)<>0 Then
					$nWinAdded = BitOR($nWinAdded,$mask)
				Else
					$nWinLacks = BitOR($nWinLacks,$mask)
				EndIf
			EndIf
		Next
	EndIf
	Local $nWinExLacks=0,$nWinExAdded=0
	If $gWinOutExStyles<>"" and $gWinOutExStyles<>$gWinInExStyles Then
		For $iShft = 0 to 31
			$mask = BitShift(1,-$iShft)		; negative is left
			If BitAND($gWinOutExStyles,$mask)<>BitAND($gWinInExStyles,$mask) Then
				If BitAND($gWinOutExStyles,$mask)<>0 Then
					$nWinExAdded = BitOR($nWinExAdded,$mask)
				Else
					$nWinExLacks = BitOR($nWinExLacks,$mask)
				EndIf
			EndIf
		Next
	EndIf
	ShowAllStyles($nWinLacks,$nWinExLacks,$edtStylesWinLacks)
	ShowAllStyles($nWinAdded,$nWinExAdded,$edtStylesWinAdded)
EndFunc

Func ShowAllStyles($nStyles,$nExStyles,$ctrlID)
	Local $t=""
	For $i = 0 to UBound($kStylesAr,1)-1
		If BitAND($nStyles,$kStylesAr[$i][0])=$kStylesAr[$i][0] Then
			$t &= "," & @CRLF & $kStylesAr[$i][1]
			$nStyles = BitAND($nStyles,BitNOT($kStylesAr[$i][0]))
		EndIf
	Next
	If $nStyles<>0 Then
		MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown style(s) 0x" & Hex($nStyles))
	EndIf
	For $i = 0 to UBound($kExStylesAr,1)-1
		If BitAND($nExStyles,$kExStylesAr[$i][0])=$kExStylesAr[$i][0] Then
			$t &= "," & @CRLF & $kExStylesAr[$i][1]
			$nExStyles = BitAND($nExStyles,BitNOT($kExStylesAr[$i][0]))
		EndIf
	Next
	If $nExStyles<>0 Then
		MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown exStyle(s) 0x" & Hex($nStyles))
	EndIf
	$t = StringMid($t,4)
	GUICtrlSetData($ctrlID,$t)
EndFunc

Func ShowTestForm()
	If Not IsChecked($chkShowTestForm) Then Return
Opt("GUICloseOnESC",1)
$TestForm = GUICreate("TestForm", 196, 161, 790, 274,$gParamStyles,$gParamExStyles)
GUICtrlCreateLabel("Press Esc key to close", 8, 8, 164, 17)
GUISetState(@SW_SHOW)
	WinSetState($Form1,"",@SW_DISABLE)
	GUISwitch($TestForm)

	While 1
		Local $nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE;,$btnOK
				ExitLoop
		EndSwitch
	WEnd
Opt("GUICloseOnESC",0)
	WinSetState($Form1,"",@SW_ENABLE)
	GUISwitch($Form1)
	GUIDelete($TestForm)
EndFunc

; Copied from WinAPI.au3
Func _C_GetWindowLong($hWnd, $iIndex)
	Local $sFuncName = "GetWindowLongW"
	If @AutoItX64 Then  $sFuncName = "GetWindowLongPtrW"
	Local $aResult = DllCall("user32.dll", "long_ptr", $sFuncName, "hwnd", $hWnd, "int", $iIndex)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc   ;==>_C_GetWindowLong

Func ConvertExStylesToText($nExStyles)
Local $t = ""
	For $i = 0 to UBound($kExStylesAr,1)-1
		If BitAND($nExStyles,$kExStylesAr[$i][0])=$kExStylesAr[$i][0] Then
			$nExStyles = BitAND($nExStyles,BitNOT($kExStylesAr[$i][0]))
			$t &= "," & @CRLF & $kExStylesAr[$i][1]
		EndIf
	Next
	If $nExStyles<>0 Then
		MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown ExStyle(s) 0x" & Hex($nExStyles))
	EndIf
	$t = StringMid($t,4)
	Return $t
EndFunc
